
###
### ProjectListe Class
###
package ProjectListe;

use Tk;

local $topWindow;
local $MASTERFILE;
local $DIR;
local $LISTE;

###
### $pr_liste = ProjectListe->new($topwindow) - Neue ProjectListe
###
sub new {
    my($type, $parentwin) = @_;

    my $self = {};
                                            
    $self->{'parentwin'}   = $parentwin;

    bless($self, $type);
}


###
### $pr_liste->start("Master-File") - ProjectListe anzeigen
###
sub start {
    $self     = shift;
    my $file    = shift;
	$MASTERFILE = &basename($file);

    $topWindow=$self->{'topwin'} = $self->{'parentwin'}->Toplevel();

    $self->{'topwin'}->configure(-title => "$file");

	$LISTE = $self->{'topwin'}->ScrlListbox(-label => "INCLUDE-Liste",
							-background => "white", 
							-height => 15, -width => 45,
							-selectmode => "single");
	$LISTE->pack(-fill => 'both', -expand => 'yes', -side => 'top');

    $self->{'topwin'}->Button(-text => "ffnen", 
      -command => sub { \&openfile() })->pack(-side => 'left');
	$LISTE->bind("<Double-Button-1>" => \&openfile);

    $self->{'topwin'}->Button(-text => "Schlieen", 
      -command => sub { $self->{'topwin'}->destroy() } 
                             )->pack(-side => 'right');

	# Projektliste fuellen
	&fill_the_list($MASTERFILE,0);
}

sub fill_the_list {
my $file = shift;
my $plane = shift;
my $line;
my $include_file;
my $verbatim;
my ($FILE) = "INPUT_$file";	# Daskriptor generieren
my $tab="";
my $i=0;

  while ($i < $plane) {
	$tab = $tab."   ";
	$i++;
  }
  $LISTE->insert("end", "$tab $file");
  open($FILE, $file) || return 0;
  while($line=<$FILE>) {
	 $line =~ s/([^\\])%(\s*)(.*)$/$1/s;
	 if (($line =~ /^(.*)#(INCLUDE)(\s*){(\s*)(.*)(\s*)}/)&&(!($verbatim))) {
		$include_file = $5;
		$include_file .= ".mas" unless ($include_file =~ /\.(\w+)$/);
		&fill_the_list($include_file,$plane+1);
	} elsif ($line =~ /^(\s*)\\begin{verbatim}(\s*)/) {
		$verbatim=1;
	} elsif ($line =~ /^(\s*)\\end{verbatim}(\s*)/) {
		$verbatim=0;
	}
  }
  close FILE;
}

sub basename {
my $file = shift;
my $tmp = $file;

  	$tmp =~ s/[^\/]+$//;
  	$file =~ s/$tmp//;
	$DIR = $tmp;

	return $file;
}

sub openfile {
my $file;
my $editor=Editor->new($topWindow);
	
 $file = $LISTE->Getselected;
 $editor->start($file, "", ""); 
}

1;
