
###
### Konfigurator
###
package Konfigurator;

use Tk;

local $top;
local $photo_applet;
local %photo;
local $BGCOLOR;
local $backgroundcolor_button;
local $textcolor_button;
local $TEXTCOLOR;
local $ICONSERVER;
local $MAS2TEX_DIR;
local $icon_type;
local %icons;
local %iconsizes;

###
### $kf = Konfigurator->new($topwindow) - Neue Konfigurator-Instanz
###
sub new {
    my($type, $parentwin) = @_;

    my $self = {};
                                            
    $self->{'parentwin'}   = $parentwin;

    bless($self, $type);
}


###
### $kf->start("dir") - Konfigurator starten
###
sub start {
    my $self     = shift;
	my $dir 	 = shift;
	$BGCOLOR = "#FFFFFF";
	$TEXTCOLOR = "#000000";
	$MAS2TEX_DIR=$main::MAS2TEX_DIR;
	$ICONSERVER="$MAS2TEX_DIR/icons";

	chop(my $startdir = $dir);

	$dir =~ s/\/$//;	
	&load_initfile($dir);

    $top = $self->{'topwin'} = $self->{'parentwin'}->Toplevel();

    $top->configure(-title => "$dir/.m2t-init");

	my $java_path  = Fs->new($top, \&get_java_path,"Suche Java-Verzeichnis","directory","");
	my $java_doc_path  = Fs->new($top, \&get_java_doc_path,"Suche Doc-Verzeichnis","directory","");
	my $applet_path  = Fs->new($top, \&get_applet_path,"Suche Applet-Verzeichnis","directory","");
	my $applet_image  = Fs->new($top, \&get_applet_image,"Suche Applet-Bild","gif","");
	my $background_image  = Fs->new($top, \&get_background_image,"Suche Hintergrund-Bild","","");
	my $back_cl  = Color->new($top, \&set_back_color,"Hintergrundfarbe");
	my $text_cl  = Color->new($top, \&set_text_color,"Textfarbe");
	my $iconserver_path  = Fs->new($top, \&get_iconserver_path,"Suche Icon-Verzeichnis","directory","");

	my $frame1 = $top->Frame();
	my $frame1_1 = $frame1->Frame();
	my $bilder = $frame1_1->Frame(-borderwidth => 2, -relief => 'groove');
	$bilder->Label(-text=>"Bilder")->pack(-side => 'top');
	$bilder->Checkbutton(-text => "transparent",
						-variable => \$USE_TRANSPARENT,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'top',-anchor => "w"); 
	$bilder->Checkbutton(-text => "Antialiasing",
						-variable => \$USE_IMAGES_ANTIALIAS,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'top',-anchor => "w"); 
	$bilder->Checkbutton(-text => "zentriert",
						-variable => \$USE_CENTER,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'top',-anchor => "w"); 
	$bilder->Checkbutton(-text => "als Gleitobjekte",
						-variable => \$USE_FIGURE,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'top',-anchor => "w");
	my $sk_faktor = $bilder->Frame(); 
	$sk_faktor->Label(-text=>"Skalierungsfaktor (HTML)")->pack(-side => 'left');
	$sk_faktor->Entry(-background => "white",-width => 4,
						-textvariable => \$USE_SCALE)->pack(-side => 'right',-anchor => "e"); 
	$sk_faktor -> pack(-side => 'top',- anchor => "w",-expand => 'yes',-fill => "x");
	my $faktor = $bilder->Frame(); 
	$faktor->Label(-text=>"FigTeX-Faktor (LaTeX)")->pack(-side => 'left');
	$faktor->Entry(-background => "white",-width => 4,
						-textvariable => \$USE_FACTOR)->pack(-side => 'right',-anchor => "e"); 
	$faktor -> pack(-side => 'top',- anchor => "w",-expand => 'yes',-fill => "x");

	$bilder->pack(-side => 'left', -expand => "yes", -fill => "both");
	$frame1_1->Canvas(-width => 1, -height => 1)->pack(-side=>'left');

	my $show = $frame1_1->Frame(-borderwidth => 2, -relief => 'groove');
	$show->Label(-text=>"Show-Bilder")->pack(-side => 'top');
	$show->Checkbutton(-text => "transparent",
						-variable => \$USE_SHOW_TRANSPARENT,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'top',-anchor => "w"); 
	$show->Checkbutton(-text => "zentriert",
						-variable => \$USE_SHOW_CENTER,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'top',-anchor => "w"); 
	$show->Checkbutton(-text => "Antialiasing",
						-variable => \$USE_SHOW_ANTIALIAS,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'top',-anchor => "w");
	my $sk_show_faktor = $show->Frame(); 
	$sk_show_faktor->Label(-text=>"Skalierungsfaktor (HTML)")->pack(-side => 'left');
	$sk_show_faktor->Entry(-background => "white",-width => 4,
						-textvariable => \$USE_SHOW_SCALE)->pack(-side => 'right',-anchor => "e"); 
	$sk_show_faktor -> pack(-side => 'top',- anchor => "w",-expand => 'yes',-fill => "x");

	$show->pack(-side => 'right', -expand => "yes", -fill => "both");

	$frame1_1->pack(-side=>'top', -expand => "yes", -fill => "both");
	$frame1->Canvas(-width => 1, -height => 1)->pack(-side=>'top');
	
	my $java = $frame1->Frame(-borderwidth => 2, -relief => 'groove');
	$java->Label(-text=>"Java-Applets")->pack(-side => 'top');

	my $java1 = $java->Frame();
	$java1->Label(-text=>"Java-Verzeichnis",-width=>18)->pack(-side=>'left');
	$java1->Entry(-background => "white",-width => 35,
						-textvariable => \$USE_JAVA_PATH)->pack(-side => 'left');
	$java1->Button(-text=>"Suchen...", 
                    -command => sub { $java_path->start($startdir)})
					->pack(-side => 'left');
	$java1->pack(-side => 'top',-anchor => "w");

	my $java2 = $java->Frame();
	$java2->Label(-text=>"Doc-Verzeichnis",-width=>18)->pack(-side=>'left');
	$java2->Entry(-background => "white",-width => 35,
						-textvariable => \$USE_JAVADOC_PATH)->pack(-side => 'left');
	$java2->Button(-text=>"Suchen...", 
                    -command => sub { $java_doc_path->start($startdir)})
					->pack(-side => 'left');
	$java2->pack(-side => 'top',-anchor => "w");

	my $java3 = $java->Frame();
	$java3->Label(-text=>"Applet-Verzeichnis",-width=>18)->pack(-side=>'left');
	$java3->Entry(-background => "white",-width => 35,
						-textvariable => \$USE_APPLET_PATH)->pack(-side => 'left');
	$java3->Button(-text=>"Suchen...", 
                    -command => sub { $applet_path->start($startdir)})
					->pack(-side => 'left');
	$java3->pack(-side => 'top',-anchor => "w");

	my $java4 = $java->Frame();
	$java4->Label(-text=>"Applet-Bild",-width=>18)->pack(-side=>'left');
	$java4->Entry(-background => "white",-width => 35,
						-textvariable => \$USE_APPLET_IMAGE)->pack(-side => 'left');
    $photo_applet = $java4->Photo();
	$USE_APPLET_IMAGE = "/home/mm/Master/icons/duke.gif" unless ($USE_APPLET_IMAGE);
	if (-f "$USE_APPLET_IMAGE") {
		$photo_applet->configure(-file => $USE_APPLET_IMAGE);
	} else {
		$photo_applet->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$java4->Button(-image=>$photo_applet,
					-width => 40,
					-height => 40,
                    -command => sub { $applet_image->start($startdir)})
					->pack(-side => 'left');
	$java4->pack(-side => 'top',-anchor => "w");

	$java->Checkbutton(-text => "Applets einbetten",
						-variable => \$USE_APPLET_EMBED,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'top',-anchor => "w"); 
	$java->pack(-side => 'top', -expand => "yes", -fill => "both");
	
	$frame1->pack(-side=>'top', -expand => "yes", -fill => "both");
	$top->Canvas(-width => 1, -height => 1)->pack(-side=>'left');

	my $html_layout = $top->Frame(-borderwidth => 2, -relief => 'groove');
	$html_layout->Label(-text=>"HTML-Layout")->pack(-side => 'top');

	my $background_file = $html_layout->Frame();
	$background_file->Label(-text=>"Hintergrundbild")->pack(-side=>'left');
	$background_file->Entry(-background => "white",-width => 35,
						-textvariable => \$BACKGROUND)->pack(-side => 'left');
	$background_file->Button(-text=>"Suchen ...",
                   		-command => sub { $background_image->start($startdir)})
						->pack(-side => 'left');
	$background_file->pack();
	
	$background_color = $html_layout->Frame();
	$background_color->Label(-text=>"Hintergrundfarbe",-width=>16)->pack(-side=>'left');
	$background_color->Entry(-background => "white",-width => 8,
						-textvariable => \$BGCOLOR)->pack(-side => 'left');
	$backgroundcolor_button = $background_color->Button(-background=>$BGCOLOR,
                   			 -command => sub { $back_cl->start($BGCOLOR) })
								->pack(-side => 'left');
	$background_color->pack();
	
	$text_color = $html_layout->Frame();
	$text_color->Label(-text=>"Schriftfarbe",-width=>16)->pack(-side=>'left');
	$text_color->Entry(-background => "white",-width => 8,
						-textvariable => \$TEXTCOLOR)->pack(-side => 'left');
	$textcolor_button = $text_color->Button(-background=>$TEXTCOLOR,
                       		-command => sub { $text_cl->start($TEXTCOLOR) })
					   		->pack(-side => 'left');
	$text_color->pack();


	my $leiste = $html_layout->Frame();
	my $leiste1 = $leiste->Frame();
	my $leiste2 = $leiste->Frame();

	$leiste1->Checkbutton(-text => "untere Navigationsleiste",
						-variable => \$BOTTOM_NAVIGATION,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'left',-anchor => "w"); 

	$leiste1->Checkbutton(-text => "Wrter in unterer Leiste",
						-variable => \$words_in_bottom_page,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'right',-anchor => "e"); 
	
	$leiste2->Checkbutton(-text => " obere Navigationsleiste",
						-variable => \$TOP_NAVIGATION,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'left',-anchor => "w"); 

	$leiste2->Checkbutton(-text => "Wrter in oberer Leiste",
						-variable => \$words_in_top_page,
						-onvalue => "1",
						-offvalue => "")->pack(-side => 'right',-anchor => "e"); 

	$leiste1->pack(-side=>'bottom');	
	$leiste2->pack(-side=>'bottom');	
	$leiste->pack(-side=>'bottom');	

    my $nav_image = $html_layout->Photo();
	$nav_image->configure(-file => "$main::MTK_DIR/images/navigation.gif");
	$html_layout->Button(-image=>$nav_image, 
                    -command => sub { &navigation })
					->pack(-side=>'bottom');

	my $frame2 = $top->Frame();
	$frame2->Button(-text=>"Sichern",
                    -command => sub { &write_initfile($dir) })
					->pack(-side => 'left');
	$frame2->Button(-text=>"Beenden",
                    -command => sub { $top->destroy() })
					->pack(-side => 'right');
	$frame2->pack(-side => 'bottom');
	
	$html_layout->pack(-side => 'bottom');
}

sub load_initfile {
my $dir = shift;
my $nbutton;
my $nbutton_size;

	# Die INIT-Datei lesen (nach Prioritaet)
	if (-f "$main::MAS2TEX_DIR/mas2tex.config") {
		require("$main::MAS2TEX_DIR/mas2tex.config");	
	}
	if (-f "$ENV{'HOME'}/.m2t-init") {
		require("$ENV{'HOME'}/.m2t-init");	
	}
	# Wenn Config-Datei existiert 
	if (-f "$dir/.m2t-init") {
    	require("$dir/.m2t-init");
	}
	
	foreach $nbutton (keys(%iconsizes)) {
		$nbutton_size = $iconsizes{"$nbutton"};
		$nbutton_size =~ s/(WIDTH|HEIGHT)(\s*)=(\s*)//g;
		($iconsizes{"$nbutton"."_w"},$iconsizes{"$nbutton"."_h"}) = split ' ', $nbutton_size;
			
	}
	
}

sub write_initfile {
my $dir = shift;

open(INIT,">$dir/.m2t-init");
print INIT "\#\#\# Mas2TeX Init-Datei\n".
		   "\# Generiert mit mas2tex-Tk - Konfigurator\n\n";

 print INIT "\# Mitkopieren von Quellen erlaubt\n";
 print INIT "\$COPY_SOURCE = \"$COPY_SOURCE\"\;	\n\n";

 print INIT "\# die Htmllinks lokal ablegen (kopieren)\n";
 print INIT "\# relevant in Verbindung mit \$COPY_SOURCE\n";
 print INIT "\$HTMLLINK_COPY=\"$HTMLLINK_COPY\"\;\n\n";

 print INIT "\# die Icons werden lokal abgelegt\n";
 print INIT "\$LOCAL_ICONS=\"$LOCAL_ICONS\"\;		\n\n";

 print INIT "\# Transparenz der Bilder in HTML\n";
 print INIT "\$USE_TRANSPARENT=\"$USE_TRANSPARENT\"\;	\n";
 print INIT "\$USE_IMAGES_ANTIALIAS=\"$USE_IMAGES_ANTIALIAS\"\;	\n\n";
		
 print INIT "\# Zentrierung von Quellen\n";
 print INIT "\$USE_CENTER=\"$USE_CENTER\"\;	\n\n";
		
 print INIT "\# Report-Fonts (normalsize,large,Large,...)\n";
 print INIT "\$REPORT_FONT=\"$REPORT_FONT\"\;		\n";

print INIT "\# Font fuer VIEWCODE-Dateien\n";
print INIT "\# (tiny,scriptsize,footnotesize,small,normalsize,large,...)\n";
print INIT "\$VIEWCODE_FONT=\"$VIEWCODE_FONT\"\; \n";

 print INIT "\# Bilder als Gleitobjekte\n";
 print INIT "\$USE_FIGURE=\"$USE_FIGURE\"\;		\n";
 print INIT "\# Tabellen als Gleitobjekte\n";
 print INIT "\$USE_TABLE=\"$USE_TABLE\"\;		\n";
 print INIT "\# Optionen fuer die Gleitobjekte\n";
 print INIT "\$FIGURE_OPTIONS=\"$FIGURE_OPTIONS\"\;	\n\n";

 print INIT "\# Einbettung von Quellen in HTML\n";
 print INIT "\$USE_EMBED=\"$USE_EMBED\"\;	\n\n";
		
 print INIT "\# Einbettung von Java-Applets in HTML\n";
 print INIT "\$USE_APPLET_EMBED=\"$USE_APPLET_EMBED\"\;\n\n";

 print INIT "\# Skalierungsfaktor fuer die Bilder \[0,..,4\]\n\n";
 print INIT "\$USE_SCALE=\"$USE_SCALE\"\;\n\n";
		
 print INIT "\# Faktor fuer die FigTeX-Bilder\n";
 print INIT "\$USE_FACTOR=\"$USE_FACTOR\"\;\n\n";
 		
 print INIT "\# Transparenz der SHOW-Bilder\n";
 print INIT "\$USE_SHOW_TRANSPARENT=\"$USE_SHOW_TRANSPARENT\"\;\n";
 print INIT "\# Skalierungsfaktor fuer die SHOW-Bilder \[0,..,4\]\n";
 print INIT "\$USE_SHOW_SCALE=\"$USE_SHOW_SCALE\"\;\n";
 print INIT "\# Zentrierung fuer die SHOW-Bilder\n";
 print INIT "\$USE_SHOW_CENTER=\"$USE_SHOW_CENTER\"\;\n";
 print INIT "\# Antialiasieng fuer die SHOW-Bilder\n";
 print INIT "\$USE_SHOW_ANTIALIAS=\"$USE_SHOW_ANTIALIAS\"\;	\n\n";

 print INIT "\# Verzeichnis mit Java-Quellen\n";
 print INIT "\$USE_JAVA_PATH=\"$USE_JAVA_PATH\"\;\n";
 print INIT "\# Verzeichnis mit der Java-Dokumentation\n";
 print INIT "\$USE_JAVADOC_PATH=\"$USE_JAVADOC_PATH\"\;\n";
 print INIT "\# Verzeichnis mit Java-Applets\n";
 print INIT "\$USE_APPLET_PATH=\"$USE_APPLET_PATH\"\;\n";
 print INIT "\# Bild, das als Link fuer ein Applet \n";
 print INIT "\# eingesetzt wird\n";
 print INIT "\$USE_APPLET_IMAGE=\"$USE_APPLET_IMAGE\"\;\n\n";


 print INIT "\# ---------------------------------\n";
 print INIT "\#\#\# HTML-Dokument Einstellungen \#\#\#\n";
 print INIT "\# ---------------------------------\n\n";

 print INIT "\# Hintergrundbild fuer HTML-Seiten\n";
 print INIT "\$BACKGROUND=\"$BACKGROUND\"\;\n\n";

 print INIT "\# Hintergrundfarbe\n";
 print INIT "\$BGCOLOR=\"$BGCOLOR\"\;\n\n";

 print INIT "\# Textfarbe\n";
 print INIT "\$TEXTCOLOR = \"$TEXTCOLOR\"\;\n\n";

 print INIT "\# Textgroesse\n";
 print INIT "\$FONT_SIZE = \"$FONT_SIZE\"\;\n\n";

 print INIT "\# HTML-Font fuer die Quellen-Unterschrift\n";
 print INIT "\$HTML_SIGN_FONT=\"$HTML_SIGN_FONT\"\;\n\n";

 print INIT "\# Titel fuer HTML-Dokument\n";
 print INIT "\$TITLE = \"$TITLE\"\;      \n\n";

 print INIT "\# Kurze Information z.B. Name+Datum\n";
 print INIT "\# Erscheint unten auf jeder HTML-Seite\n";
 print INIT "\$ADDRESS = \"$ADDRESS\"\;\n\n";

 print INIT "\# wenn $INFO wahr, dann wird\n";
 print INIT "\# am Ende des HTML-Dokuments\n";
 print INIT "\# eine Informationsdatei generiert\n";
 print INIT "\$INFO = \"$INFO\"\;\n\n";

 print INIT "\# HTML-Code wird fuer den Netscape-Browser\n";
 print INIT "\# optimiert\n";
 print INIT "\$NETSCAPE_HTML = \"$NETSCAPE_HTML\"\;\n";
 print INIT "\# HTML-Version\n";
 print INIT "\$HTML_VERSION = \"$HTML_VERSION\"\;\n\n";

 print INIT "\# Obere Navigationsleiste einblenden\n";
 print INIT "\$TOP_NAVIGATION=\"$TOP_NAVIGATION\"\;\n\n";

 print INIT "\# Untere Navigationsleiste einblenden\n";
 print INIT "\$BOTTOM_NAVIGATION=\"$BOTTOM_NAVIGATION\"\;\n\n";

 print INIT "\# Die untere Navigationsleiste einblenden\n";
 print INIT "\# falls die Anzahl der Worte in der HTML-Seite\n";
 print INIT "\# \$WORDS_IN_PAGE ueberschreitet \n";
 print INIT "\$AUTO_NAVIGATION=\"$AUTO_NAVIGATION\"\;\n";
 print INIT "\$WORDS_IN_PAGE=\"$WORDS_IN_PAGE\"\;\n\n";

 print INIT "\# ----------------------------------\n";
 print INIT "\#\#\#      Navigation Panel        \#\#\#\n";
 print INIT "\#-----------------------------------\n\n";

 print INIT "\# Verzeichnis mit den Navigationsicons\n";
 print INIT "\$ICONSERVER=\"$ICONSERVER\"\;\n\n";

 print INIT "\# Icons-Dateinamen\n";
 print INIT "\%icons =				\n";
 print INIT "(\n";
 print INIT "\'up\' , \'$icons{up}\',\n";
 print INIT "\'up_inactive\', \'$icons{up_inactive}\',\n";
 print INIT "\'next\', \'$icons{next}\',\n";
 print INIT "\'next_inactive\', \'$icons{next_inactive}\',\n";
 print INIT "\'previous\', \'$icons{previous}\',\n";
 print INIT "\'previous_inactive\', \'$icons{previous_inactive}\',\n";
 print INIT "\'contents\', \'$icons{contents}\',\n";
 print INIT "\'index\', \'$icons{index}\',\n";
 print INIT "\'footnote\', \'$icons{footnote}\',\n";
 print INIT "\'cross_ref\', \'$icons{cross_ref}\',\n";
 print INIT ")\;\n\n";

 print INIT "\# Iconsgroessen in Pixel\n";
 print INIT "\%iconsizes = 			\n";
 print INIT "(\n";
 print INIT "\'up\', \'WIDTH=$iconsizes{up_w} HEIGHT=$iconsizes{up_h}\',\n";
 print INIT "\'next\', \'WIDTH=$iconsizes{next_w} HEIGHT=$iconsizes{next_h}\',\n";
 print INIT "\'previous\', \'WIDTH=$iconsizes{previous_w} HEIGHT=$iconsizes{previous_h}\',\n";
 print INIT "\'contents\', \'WIDTH=$iconsizes{contents_w} HEIGHT=$iconsizes{contents_h}\',\n";
 print INIT "\'index\', \'WIDTH=$iconsizes{index_w} HEIGHT=$iconsizes{index_h}\',\n";
 print INIT ")\;\n\n";


 print INIT "\# Das Aussehen der Navigations-Panel\n";
 print INIT "\# Moegliche Werte : \$PREVIOUS, \$UP, \$NEXT, \$CONTENTS, \$INDEX, \$CUSTOM_BUTTONS\n";
 print INIT "\# und beliebige HTML-Tags\n\n";

 print INIT "\# das Aussehen der oberen Navigationsleiste\n";
 print INIT "\$top_Nav_Panel=\'$top_Nav_Panel\'\;\n\n";

 print INIT "\# Woerter in der oberen Leiste erlauben\n";
 print INIT "\$words_in_top_page=\"$words_in_top_page\";\n\n";

 print INIT "\# das Aussehen der unteren Navigationsleiste\n";
 print INIT "\$bot_Nav_Panel=\'$bot_Nav_Panel\'\;\n\n";

 print INIT "\# Woerter in der unteren Leiste erlauben\n";
 print INIT "\$words_in_bot_page=\"$words_in_bot_page\"\;\n\n";

 print INIT "1\;\t\# Diese Zeile muss die letzte sein\n";

close(INIT);
}

sub navigation {
	my $toplevel=$top->Toplevel();
	$toplevel->configure(-title=>"Navigationsleiste");
	my $icon = $toplevel->Frame(-borderwidth => 2, -relief => 'groove');
	$icon->Label(-text=>"Navigationsleiste")->pack(-side => 'top');

	my $icon0 = $icon->Frame();
	$icon0->Label(-text=>"Icons-Verzeichnis")->pack(-side=>'left');
	$icon0->Entry(-background => "white",-width => 35,
						-textvariable => \$ICONSERVER)->pack(-side => 'left');
	$icon0->Button(-text=>"Suchen...", 
                    -command => sub { $iconserver_path->start($ICONSERVER)})
					->pack(-side => 'left');
	$icon0->pack(-side => 'top',-anchor => "w");

	my $icon1 = $icon->Frame();
	$icon1->Label(-width=>8)->pack(-side=>'left');
	$icon1->Label(-text=>"Prev", -width=>5)->pack(-side=>'left');
	$icon1->Canvas(-width => 22, -height => 10)->pack(-side=>'left');
	$icon1->Label(-text=>"Up", -width=>5)->pack(-side=>'left');
	$icon1->Canvas(-width => 22, -height => 10)->pack(-side=>'left');
	$icon1->Label(-text=>"Home", -width=>5)->pack(-side=>'left');
	$icon1->Canvas(-width => 22, -height => 10)->pack(-side=>'left');
	$icon1->Label(-text=>"Index", -width=>5)->pack(-side=>'left');
	$icon1->Canvas(-width => 22, -height => 10)->pack(-side=>'left');
	$icon1->Label(-text=>"Next", -width=>5)->pack(-side=>'left');
	$icon1->pack(-side=>'top');

	my $icon2 = $icon->Frame();
	$icon2->Label(-text=>"aktive", -width => 8)->pack(-side=>'left');
    $photo{'prev'} = $icon2->Photo();
	$icons{'previous'} = "prev.gif" unless ($icons{'previous'});
	if (-f "$ICONSERVER/$icons{previous}") {
		$photo{'prev'}->configure(-file => "$ICONSERVER/$icons{'previous'}");
	} else {
		$photo{'prev'}->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$icon2->Button(-image=>$photo{'prev'},
					-width => 45,
					-height => 40,
                    -command => sub { $icons{'previous'}=&get_icons("prev") })
					->pack(-side => 'left');
	$icon2->Canvas(-width => 10, -height => 10)->pack(-side=>'left');
    $photo{'up'} = $icon2->Photo();
	$icons{'up'} = "up.gif" unless ($icons{'up'});
	if (-f "$ICONSERVER/$icons{up}") {
		$photo{'up'}->configure(-file => "$ICONSERVER/$icons{'up'}");
	} else {
		$photo{'up'}->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$icon2->Button(-image=>$photo{'up'},
					-width => 45,
					-height => 40,
                    -command => sub { $icons{'up'}=&get_icons("up") })
					->pack(-side => 'left');
	$icon2->Canvas(-width => 10, -height => 10)->pack(-side=>'left');
    $photo{'contents'} = $icon2->Photo();
	$icons{'contents'} = "inhalt.gif" unless ($icons{'contents'});
	if (-f "$ICONSERVER/$icons{contents}") {
		$photo{'contents'}->configure(-file => "$ICONSERVER/$icons{'contents'}");
	} else {
		$photo{'contents'}->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$icon2->Button(-image=>$photo{'contents'},
					-width => 45,
					-height => 40,
                    -command => sub { $icons{'contents'}=&get_icons("contents") })
					->pack(-side => 'left');
	$icon2->Canvas(-width => 10, -height => 10)->pack(-side=>'left');
    $photo{'index'} = $icon2->Photo();
	$icons{'index'} = "index.gif" unless ($icons{'index'});
	if (-f "$ICONSERVER/$icons{index}") {
		$photo{'index'}->configure(-file => "$ICONSERVER/$icons{'index'}");
	} else {
		$photo{'index'}->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$icon2->Button(-image=>$photo{'index'},
					-width => 45,
					-height => 40,
                    -command => sub { $icons{'index'}=&get_icons("index") })
					->pack(-side => 'left');
	$icon2->Canvas(-width => 10, -height => 10)->pack(-side=>'left');
    $photo{'next'} = $icon2->Photo();
	$icons{'next'} = "next.gif" unless ($icons{'next'});
	if (-f "$ICONSERVER/$icons{next}") {
		$photo{'next'}->configure(-file => "$ICONSERVER/$icons{'next'}");
	} else {
		$photo{'next'}->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$icon2->Button(-image=>$photo{'next'},
					-width => 45,
					-height => 40,
                    -command => sub { $icons{'previous'}=&get_icons("next") })
					->pack(-side => 'left');
	$icon2->pack(-side=>'top');
	
	my $icon3 = $icon->Frame();
	$icon3->Label(-text=>"unaktive", -width => 8)->pack(-side=>'left');
    $photo{'previous_inactive'} = $icon3->Photo();
	$icons{'previous_inactive'} = "prev_gr.gif" unless ($icons{'previous_inactive'});
	if (-f "$ICONSERVER/$icons{previous_inactive}") {
		$photo{'previous_inactive'}->configure(-file => "$ICONSERVER/$icons{'previous_inactive'}");
	} else {
		$photo{'previous_inactive'}->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$icon3->Button(-image=>$photo{'previous_inactive'},
					-width => 45,
					-height => 40,
                    -command => sub { $icons{'previous_inactive'}=&get_icons("previous_inactive") })
					->pack(-side => 'left');
	$icon3->Canvas(-width => 10, -height => 10)->pack(-side=>'left');
    $photo{'up_inactive'} = $icon3->Photo();
	$icons{'up_inactive'} = "up_gr.gif" unless ($icons{'up_inactive'});
	if (-f "$ICONSERVER/$icons{up_inactive}") {
		$photo{'up_inactive'}->configure(-file => "$ICONSERVER/$icons{'up_inactive'}");
	} else {
		$photo{'up_inactive'}->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$icon3->Button(-image=>$photo{'up_inactive'},
					-width => 45,
					-height => 40,
                    -command => sub { $icons{'up_inactive'}=&get_icons("up_inactive") })
					->pack(-side => 'left');

	$icon3->Canvas(-width => 72 , -height => 40)->pack(-side=>'left');
	$icon3->Canvas(-width => 73, -height => 40)->pack(-side=>'left');

    $photo{'next_inactive'} = $icon3->Photo();
	$icons{'next_inactive'} = "next_gr.gif" unless ($icons{'next_inactive'});
	if (-f "$ICONSERVER/$icons{next_inactive}") {
		$photo{'next_inactive'}->configure(-file => "$ICONSERVER/$icons{'next_inactive'}");
	} else {
		$photo{'next_inactive'}->configure(-file => "$main::MTK_DIR/images/frage.gif");
	}
	$icon3->Button(-image=>$photo{'next_inactive'},
					-width => 45,
					-height => 40,
                    -command => sub { $icons{'next_inactive'}=&get_icons("next_inactive") })
					->pack(-side => 'left');
	$icon3->pack(-side=>'top');

	my $icon4 = $icon->Frame();
	$icon4->Label(-text=>"Pixelmae")->pack(-side=>'left');
	my $icon4_1 = $icon4 -> Frame();
	$icon4_1->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'previous_w'})->pack(-side => 'left');
	$icon4_1->Label(-text=>"x")->pack(-side=>'left');
	$icon4_1->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'previous_h'})->pack(-side => 'left');
	$icon4_1->pack(-side => 'left');
	$icon4->Canvas(-width => 5, -height => 5)->pack(-side=>'left');
	my $icon4_2 = $icon4 -> Frame();
	$icon4_2->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'up_w'})->pack(-side => 'left');
	$icon4_2->Label(-text=>"x")->pack(-side=>'left');
	$icon4_2->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'up_h'})->pack(-side => 'left');
	$icon4_2->pack(-side => 'left');
	$icon4->Canvas(-width => 5, -height => 5)->pack(-side=>'left');
	my $icon4_3 = $icon4 -> Frame();
	$icon4_3->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'contents_w'})->pack(-side => 'left');
	$icon4_3->Label(-text=>"x")->pack(-side=>'left');
	$icon4_3->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'contents_h'})->pack(-side => 'left');
	$icon4_3->pack(-side => 'left');
	$icon4->Canvas(-width => 5, -height => 5)->pack(-side=>'left');
	my $icon4_4 = $icon4 -> Frame();
	$icon4_4->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'index_w'})->pack(-side => 'left');
	$icon4_4->Label(-text=>"x")->pack(-side=>'left');
	$icon4_4->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'index_h'})->pack(-side => 'left');
	$icon4_4->pack(-side => 'left');
	$icon4->Canvas(-width => 5, -height => 5)->pack(-side=>'left');
	my $icon4_5 = $icon4 -> Frame();
	$icon4_5->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'next_w'})->pack(-side => 'left');
	$icon4_5->Label(-text=>"x")->pack(-side=>'left');
	$icon4_5->Entry(-background => "white",-width => 2,
						-textvariable => \$iconsizes{'next_h'})->pack(-side => 'left');
	$icon4_5->pack(-side => 'left');
	
	$icon4->pack(-side=>'top');

	$icon->pack(-side=>'top');

	$toplevel->Button(-text=>"Ok", 
                    -command => sub { $toplevel->destroy() })
					->pack(-side=>'top');

}
sub get_icons {
	$icon_type = shift;
	my $icsr  = Fs->new($top, \&get_icon_image,"Suche Icons","gif","in_dir_only");

	$icsr->start($ICONSERVER);
}

sub get_icon_image {
	my $file = shift;
	my $base_name = $file;;	

  	$file =~ s/[^\/]+$//;
  	$base_name =~ s/$file//;

	$icons{"$icon_type"} = $base_name;
  	
	$photo{"$icon_type"}->configure(-file => "$main::MTK_DIR/images/empty.gif");
  	$photo{"$icon_type"}->configure(-file => "$ICONSERVER/$icons{$icon_type}");
}

sub set_back_color {
	my $color = shift;

	$BGCOLOR=$color; 
	$backgroundcolor_button->configure(-background=>$BGCOLOR);
}

sub set_text_color {
	my $color =shift;

	$TEXTCOLOR=$color; 
	$textcolor_button->configure(-background=>$TEXTCOLOR);
}

sub get_java_path {
  my $dir = shift;

  $USE_JAVA_PATH=$dir;
}

sub get_java_doc_path {
  my $dir = shift;

  $USE_JAVADOC_PATH=$dir;
}

sub get_applet_path {
  my $dir = shift;

  $USE_APPLET_PATH=$dir;
}

sub get_iconserver_path {
  my $dir = shift;

  $ICONSERVER=$dir;
}

sub get_applet_image {
  my $file = shift;

  $USE_APPLET_IMAGE=$file;
  $photo_applet->configure(-file => "$main::MTK_DIR/images/empty.gif");
  $photo_applet->configure(-file => $USE_APPLET_IMAGE);
}

sub get_background_image {
  my $file = shift;

  $BACKGROUND=$file;
}
1;
