
###
### Message Dialog Widget Class
###
package MessageDialog;

use Tk;
use strict;


###
### $md = MessageDialog->new($topwindow) - Neuer MessageDialog
###
sub new {
    my($type, $parentwin) = @_;

    my $self = {};
                                            
    $self->{'parentwin'}   = $parentwin;

    bless($self, $type);
}


###
### $md->start("Titel", "MessageText") - MessageDialog anzeigen
###
sub start {
    my $self     = shift;
    my $title    = shift;
	my $width	 = shift;
    my $message  = shift;
	my $image 	 = shift;

    $self->{'topwin'} = $self->{'parentwin'}->Toplevel();

    $self->{'topwin'}->configure(-title => "$title");
	
    my $frame =  $self->{'topwin'}->Frame();
	if ($image) {
      my $photo = $self->{'topwin'}->Photo();
	  $photo->configure(-file => "$image");
      $frame->Label(-image => $photo)->pack(-side => "left");
    }

    $frame->Message(-text => "$message",
			       -width => "$width")->pack(-side => "right");

	$frame->pack(-side => "top");
    
	$self->{'topwin'}->Button(-text => "OK", 
      -command => sub { $self->{'topwin'}->destroy() } 
                             )->pack(-side => 'bottom', -anchor => "s");
}
    
1;
